﻿using Microsoft.Toolkit.Wpf.UI.Controls;
using System;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;

namespace WpfLoginApi.Login
{
    public class WpfEmbeddedBrowser 
    {
        private string _redirectUrl;

        public async Task<string> GetRedirectQueryAsync(string startUrl, string redirectUrl)
        {
            _redirectUrl = redirectUrl;

            var window = new Window()
            {
                Width = 500,
                Height = 650,
                Title = "dRofus Login"
            };

            var resultQuery = string.Empty;

            var webView = new WebView();
            var doneSemaphore = new SemaphoreSlim(0, 1);
        
            webView.NavigationStarting += (s, e) =>
            {
                if (BrowserIsNavigatingToRedirectUri(e.Uri))
                {
                    e.Cancel = true;

                    resultQuery = e.Uri.Query;

                    doneSemaphore.Release();
                    window.Close();
                }
            };

            window.Closing += (s, e) =>
            {
                doneSemaphore.Release();
            };

            window.Content = webView;
            window.Show();
            webView.Source = new Uri(startUrl);

            await doneSemaphore.WaitAsync();
            return resultQuery;
        }

        private bool BrowserIsNavigatingToRedirectUri(Uri uri)
        {
            return uri.AbsoluteUri.StartsWith(_redirectUrl);
        }
    }
}